/* LORa SX1278 TRANSMITTER example.
 * Modificado por SETA43
 * seta43.duckdns.org
 *
  Module SX1278 // Arduino UNO/NANO
    GND         ->   GND
    Vcc         ->   3.3V
    MISO        ->   D12
    MOSI        ->   D11
    SLCK        ->   D13
    Nss         ->   D10
    Di00        ->   D2
    RST         ->   D9
 */

/*
    A4->SDA
    A5->SDL
    GND->GND
    5V->VIN
*/
#include <SPI.h>
#include <LoRa.h> //  https://github.com/sandeepmistry/arduino-LoRa

#include "olex.h"
#include <Wire.h>

#define MAXLOG 100
char buffer[MAXLOG];
char bufferOUT[MAXLOG];

String inString = "";
int contador;


char buffer2[15];
char coor1[15];
char coor2[15];

char coorLo;
char coorLa;
char metros[8];
char satelites[3];
char hora[12];
char fecha[12];
char velocidad[12];
long velocidadk;


void setup()
{
    Serial.begin(9600);

    while (!Serial)  {  ;  }
    if (!LoRa.begin(433E6)) // 433E6 MHz  module
    {
        Serial.println("\nStarting LoRa failed!");
        while (1)   {   ;   }
    }
    Serial.println("\nLoRa GPS_RX\n");

    OleInit();
    xclearDisplay();
    ModeFont = 0;
    xStringAT(0, 6, "seta43.blogspot.com");
}


void loop()
{

    int packetSize = LoRa.parsePacket();
    if (packetSize)
    {
        while (LoRa.available())
        {
            int inChar = LoRa.read();
            inString += (char)inChar;
        }

        inString.toCharArray(buffer, MAXLOG);
        // Serial.println(buffer);

        getCadenaBuffer(1);
        strcpy(hora, buffer2);
        hora[6] = 0;
        getCadenaBuffer(2);
        strcpy(coor1, buffer2);
        getCadenaBuffer(3);
        coorLo = buffer2[0];
        getCadenaBuffer(4);
        strcpy(coor2, buffer2);
        getCadenaBuffer(5);
        coorLa = buffer2[0];
        getCadenaBuffer(9);
        strcpy(metros, buffer2);
        getCadenaBuffer(7);
        strcpy(satelites, buffer2);

        getSubCadenaBuffer(coor1, -8, -2);
        Serial.print(buffer2);
        Serial.print(" ");
        getSubCadenaBuffer(coor1, -7, 7);
        Serial.print(buffer2);
        Serial.print("'");
        Serial.print(coorLo);
        Serial.print(", ");
        getSubCadenaBuffer(coor2, -8, -2);
        Serial.print(buffer2);
        Serial.print(" ");
        getSubCadenaBuffer(coor2, -7, 7);
        Serial.print(buffer2);
        Serial.print("'");
        Serial.println(coorLa);

        sprintf(bufferOUT, "HORA=%s ", hora);
        xStringAT(0, 0, bufferOUT);

        sprintf(bufferOUT, "Log.=%s %c  ", coor1, coorLo);
        xStringAT(0, 1, bufferOUT);

        sprintf(bufferOUT, "Lat.=%s %c  ", coor2, coorLa);
        xStringAT(0, 2, bufferOUT);

        sprintf(bufferOUT, "Sat.=%s  ", satelites);
        xStringAT(0, 4, bufferOUT);

        sprintf(bufferOUT, "Alt.=%s  ", metros);
        xStringAT(8, 4, bufferOUT);

        delay(400);
        LoRa.beginPacket();
        LoRa.print("OKgps ");
        LoRa.endPacket();

        inString = "";
    }
}


// extrae cadena numero n, de buffer, y la almacena en buffer2
void getCadenaBuffer(int n)
{
    int z, z1, contador2, contador;
    contador = strlen(buffer);
    z1 = 0;
    for (z = 0; z < contador; z++)
    {
        if (buffer[z] == ',')
        {
            z1++;
            if (z1 == n)
                break;
        }
    }
    z++;
    contador2 = 0;
    for (; z < contador; z++)
    {
        buffer2[contador2] = buffer[z];
        if (buffer2[contador2] == ',')
        {
            buffer2[contador2] = 0;
            break;
        }
        if (contador2 < 12)   contador2++;
    }
}


// extrae cadena de cade, y la almacena en buffer2,inicio=inicio,numero=numero
// Si inicio es menos que 0 el inicio es desde el final.
void getSubCadenaBuffer(char* cade, int inicio, int numero)
{
    int contador, i, i2, n2;
    contador = strlen(cade);

    if (inicio < 0)      inicio = contador + inicio;
    if (numero < 0)
    {
        numero *= -1;
        inicio -= numero;
        n2 = inicio + numero;
    }
    else
    {
        n2 = inicio + numero - 1;
    }

    if (inicio < 0)        inicio = 0;
    if (inicio > contador)        inicio = contador;
    if (n2 > contador)        n2 = contador;

    i2 = 0;

    for (i = inicio; i <= n2; i++)
    {
        buffer2[i2] = cade[i];
        if (i2 < 14)    i2++;
    }
    buffer2[i2] = 0;
}
