/*
 * seta43.duckdns.org
 *
  Module SX1278 // Arduino UNO/NANO
    GND         ->   GND
    Vcc         ->   3.3V
    MISO        ->   D12
    MOSI        ->   D11
    SLCK        ->   D13
    Nss         ->   D10
    Di00        ->   D2
    RST         ->   D9
 */
/*
 A4->SDA
 A5->SDL
 GND->GND
 5V->VIN
*/
 
#include <Wire.h>
#include "olexM.h"

 
#include <SPI.h>
#include <LoRa.h> //  https://github.com/sandeepmistry/arduino-LoRa


#include <SoftwareSerial.h>

SoftwareSerial mySerial(8, 7); // RX, TX

#define BEEP 3


#define MAXBUFFER 100

char buffer[MAXBUFFER];
char bufferOUT[MAXBUFFER];

char inChar;
boolean cadeCompleta = true;
int contador,contador2;

char buffer2[15];

char coor1[15];
char coor2[15];
char coorLo;
char coorLa;
char hora[12];


String inString = ""; 


void setup()
{
    pinMode(BEEP, OUTPUT);

    Serial.begin(9600);
    while (!Serial) { ;}
    mySerial.begin(9600);

    if (!LoRa.begin(433E6)) // 433E6 MHz  module
      {
        Serial.println("Starting LoRa failed!");
        while (1){;}
      }

    Serial.println("\nLoRa GPS");
    
    OleInit();
    xclearDisplay();
    ModeFont = 0;
    xStringAT(0, 0, "seta43.duckdns.org");
}



void loop()
{
    int packetSize = LoRa.parsePacket();
    if (packetSize) 
      { 
        // read packet    
        while (LoRa.available())
        {
          int inLora = LoRa.read();
          if (contador2 < MAXBUFFER)
            {
              inString += (char)inLora;
              contador2++;
            }       
        }

        Serial.print(inString);
  
        if(0<=inString.indexOf("OKgps"))
          {
            tone(BEEP,1000); Serial.println(" OK ");
          }
        delay(50);
        noTone(BEEP);
      
        inString = "";
        contador2=0;
      }
    
  
    if (mySerial.available())
    {
        inChar = (char)mySerial.read();
        buffer[contador] = inChar;
        if (inChar == '\n')
        {
            cadeCompleta = true;
            buffer[contador] = 0;
        }
        if (contador < MAXBUFFER)   contador++;
    }

    if (cadeCompleta == true)
    {

        if (!strncmp(buffer, "$GPGGA", 6))
        {
            Serial.println(buffer);
            LoRa.beginPacket();
              LoRa.print(buffer);
            LoRa.endPacket();
            //delay(100);

            getCadenaBuffer(1);
            strcpy(hora, buffer2);
            hora[6] = 0;
            getCadenaBuffer(2);
            strcpy(coor1, buffer2);
            getCadenaBuffer(3);
            coorLo = buffer2[0];
            getCadenaBuffer(4);
            strcpy(coor2, buffer2);
            getCadenaBuffer(5);
            coorLa = buffer2[0];
            getCadenaBuffer(9);


            sprintf(bufferOUT, "Log.=%s %c  ", coor1, coorLo);
            xStringAT(0, 2, bufferOUT);
    
            sprintf(bufferOUT, "Lat.=%s %c  ", coor2, coorLa);
            xStringAT(0, 4, bufferOUT);

            sprintf(bufferOUT, "HORA=%s ", hora);
            xStringAT(0, 6, bufferOUT);
            
        }

        contador = 0;
        cadeCompleta = false;
    }
}



// extrae cadena numero n, de buffer, y la almacena en buffer2
void getCadenaBuffer(int n)
{
    int z, z1, contador2, contador;
    contador = strlen(buffer);
    z1 = 0;
    for (z = 0; z < contador; z++)
    {
        if (buffer[z] == ',')
        {
            z1++;
            if (z1 == n)
                break;
        }
    }
    z++;
    contador2 = 0;
    for (; z < contador; z++)
    {
        buffer2[contador2] = buffer[z];
        if (buffer2[contador2] == ',')
        {
            buffer2[contador2] = 0;
            break;
        }
        if (contador2 < 12)   contador2++;
    }
}
